#include "XBP.CH"
#include "APPEVENT.CH"
#include "GRA.CH"
#include "DLL.CH"
#include "COMMON.CH"

DLLFUNCTION CreateEllipticRgn(nLeftRect,nTopRect,nRightRect,nBottomRect) USING STDCALL FROM GDI32.DLL
DLLFUNCTION SetWindowRgn(hHwnd,hRgn,bRedraw) USING STDCALL FROM USER32.DLL

PROCEDURE APPSYS
RETURN

PROCEDURE MAIN()
LOCAL lExit := .F.
LOCAL hHWnd
LOCAL hRgn
LOCAL nEvent
LOCAL mp1
LOCAL mp2
LOCAL oDlg
LOCAL oXbp
LOCAL aPos
LOCAL aSize  := {400,400}
LOCAL aTmp
LOCAL nLeftRect
LOCAL nTopRect
LOCAL nRightRect
LOCAL nBottomRect

   aPos           := CenterPos(aSize,AppDesktop():currentSize())
   oDlg           := TriGradientForm():new(AppDesktop(),,aPos,aSize,,.F.)
   oDlg:Resize    := {| aOld,aNew | EVAL(oDlg:bVertex),oDlg:subPaint({0,0,aNew[1],aNew[2]})}
   oDlg:icon      := 1
   oDlg:titlebar  := .F.
   oDlg:tasklist  := .T.
   oDlg:border    := XBPDLG_NO_BORDER

   AADD(oDlg:aColor,ARRAY(3))
   oDlg:setColor(1, 255,  0,  0)
   oDlg:setColor(2, 255,255,  0)
   oDlg:setColor(3,    0,255,  0)
   oDlg:setColor(4,    0,  0,255)

   // add a call-back to create the correct vertices
   oDlg:bVertex := {|| Psycho(oDlg)}
   //
   // next, create the triangulations. Each vertex represents a single point
   // and the triangulations identify 3-points per triangle.
   oDlg:gRect := L2BIN(0)+L2BIN(1)+L2BIN(2)+;
                 L2BIN(0)+L2BIN(2)+L2BIN(3)

   oDlg:create()

/************************
************************/

   //
   // create Circle
   //
   hHwnd := oDlg:GetHwnd()
   aTmp  := oDlg:DrawingArea:Currentsize()

   nLeftRect   := 0
   nTopRect    := aTmp[2]
   nRightRect  := aTmp[1]
   nBottomRect := 0                                         // nTitlehigh
   //
   // now construct a Region and call its API function
   //
   hRgn := CreateEllipticRgn(nLeftRect,nTopRect,nRightRect,nBottomRect)
   SetWindowRgn(hHwnd,hRgn,.t.)


   SetAppWindow(oDlg)
   oDlg:show()

   SetAppFocus(oDlg)

   nEvent := xbe_None
   DO WHILE .NOT. lExit
      nEvent := AppEvent(@mp1,@mp2,@oXbp)
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            QUIT                                            // AppQuit()
      ENDCASE
      oXbp:HandleEvent(nEvent,mp1,mp2)
   ENDDO
RETURN

STATIC FUNCTION CENTERPOS(aSize,aRefSize)
RETURN { INT((aRefSize[1] - aSize[1]) / 2) ,;
         INT((aRefSize[2] - aSize[2]) / 2)   }

STATIC FUNCTION Psycho(o)
LOCAL cRet := ''
LOCAL i
LOCAL aDim := o:DrawingArea:currentSize()

   cRet := o:TriVertEx(1,       0,      0)
   cRet += o:TriVertEx(2, aDim[1],      0)
   cRet += o:TriVertEx(3, aDim[1],aDim[2])
   cRet += o:TriVertEx(4,       0,aDim[2])

RETURN (cRet)

CLASS TriGradientForm FROM GradientForm

   EXPORTED:
      METHOD INIT
      METHOD create
      METHOD buildVertex
ENDCLASS

METHOD TriGradientForm:init(oParent,oOwner,aPos,aSize,aPres,lVis)
   ::GradientForm:init(oParent,oOwner,aPos,aSize,aPres,lVis)

   AADD(::aColor,{w2bin(0),w2bin(0),w2bin(0xff00)})
   ::aColor[ 1 ]       := {w2bin(0),w2bin(0),w2bin(0x0b00)}
   ::gRect             += L2BIN(2)
   ::gradientDirection := 2                                 // 0=horiz, v=vert, 2=triangle
RETURN (self)

METHOD TriGradientForm:create(oParent,oOwner,aPos,aSize,aPres,lVis)
   ::GradientForm:create(oParent,oOwner,aPos,aSize,aPres,lVis)
RETURN (self)

METHOD TriGradientForm:buildVertex()

   ::vertex := ::TriVertEx(1)+;
               ::TriVertEx(2  ,::currentSize() [1],0)+;
               ::TriVertEx(2,0,::currentSize() [1])
RETURN (self)

CLASS GradientForm FROM XbpDialog

   EXPORTED:
      VAR aColor
      VAR gRect
      VAR gradientDirection
      VAR vertex
      VAR bVertex

      METHOD INIT
      METHOD create
      METHOD subpaint
      METHOD TriVertEx
      METHOD setColor
      METHOD buildVertex
ENDCLASS

METHOD GradientForm:init(oParent,oOwner,aPos,aSize,aPres,lVis)
   ::XbpDialog:init(oParent,oOwner,aPos,aSize,aPres,FALSE)

   ::aColor := {{w2bin(0),w2bin(0),w2bin(0x8b00)},;
                {w2bin(0),w2bin(0),w2bin(0xff00)}}
   ::gRect             := L2BIN(0)+L2BIN(1)
   ::gradientDirection := 0                                 // 0=horiz, v=vert, 2=triangle
   ::maxButton         := FALSE
   ::minButton         := TRUE

   ::XbpDialog:clipChildren             := .F.
   ::XbpDialog:drawingArea:clipChildren := .F.
RETURN (self)

METHOD GradientForm:create(oParent,oOwner,aPos,aSize,aPres,lVis)
   ::XbpDialog:create(oParent,oOwner,NIL,NIL,aPres,FALSE)

   ::maxSize           :=::currentSize()
   ::minSize           :=::currentSize()
   ::drawingArea:paint := {| aRect | self:subPaint(aRect)}
RETURN (self)

METHOD GradientForm:setColor(nIndx,nRed,nGreen,nBlue)

   DEFAULT nRed   TO 0,;
           nGreen TO 0,;
           nBlue  TO 0,;
           nIndx  TO 0

   IF nIndx > 0 .AND. nIndx <= LEN(::aColor)
      ::aColor[ nIndx ][ 1 ] := w2bin(nRed   * 256)
      ::aColor[ nIndx ][ 2 ] := w2bin(nGreen * 256)
      ::aColor[ nIndx ][ 3 ] := w2bin(nBlue  * 256)
   ENDIF
RETURN (self)

METHOD GradientForm:TriVertEx(nColor,nX,nY)

LOCAL cBuff := ''

   DEFAULT nX TO 0,nY TO 0

   cBuff += L2BIN(nX)                                       // x
   cBuff += L2BIN(nY)                                       // y

   cBuff += ::aColor[nColor][1]
   cBuff += ::aColor[nColor][2]
   cBuff += ::aColor[nColor][3]

   cBuff += w2bin(0)                                        // alpha
RETURN cBuff

METHOD GradientForm:buildVertex()
   ::vertex := ::TriVertEx(1) +;
               ::TriVertEx(2,::currentSize()[1],::currentSize()[2])
RETURN (self)

METHOD GradientForm:subpaint(aDim)

STATIC cTemplate

LOCAL nHdc
LOCAL nVertLen
LOCAL nGRectLen

   nHdc :=::drawingArea:winDevice():getHDC()

   IF cTemplate == NIL
      cTemplate := DLLPrepareCall("gdi32.dll",DLL_OSAPI,"GdiGradientFill")
   ENDIF
   IF ::vertex = NIL
      IF ::bVertex == NIL
         ::buildVertex()
      ELSE
         ::vertex := EVAL(::bVertex,self)
      ENDIF
   ENDIF
   nVertLen  := LEN(::vertex) / 16
   nGRectLen := LEN(::grect) / (4 * IIF(::gradientDirection > 1,3,2))

   DLLExecuteCall(cTemplate,nHdc,::vertex,nVertLen,::gRect,nGRectLen,::gradientDirection)

   *MSGBOX(" x1 "+LTRIM(STR(aDim[1]))+;
   *       " y1 "+LTRIM(STR(aDim[2]))+;
   *       " x2 "+LTRIM(STR(aDim[3]))+;
   *       " y2 "+LTRIM(STR(aDim[4])) )

RETURN (self)

